module("luci.controller.filebrowser",package.seeall)
local e=require"luci.http"
local t=require"luci.model.cbi.filebrowser.api"
function index()
if not nixio.fs.access("/etc/config/filebrowser")then return end
entry({"admin","nas"},firstchild(),"NAS",44).dependent=false
entry({"admin","nas","filebrowser"},cbi("filebrowser/settings"),
_("File Browser"),2).dependent=true
entry({"admin","nas","filebrowser","check"},call("action_check")).leaf=
true
entry({"admin","nas","filebrowser","download"},call("action_download")).leaf=
true
entry({"admin","nas","filebrowser","status"},call("act_status")).leaf=
true
entry({"admin","nas","filebrowser","get_log"},call("get_log")).leaf=
true
entry({"admin","nas","filebrowser","clear_log"},call("clear_log")).leaf=
true
end
local function o(t)
e.prepare_content("application/json")
e.write_json(t or{code=1})
end
function act_status()
local e={}
e.status=luci.sys.call("ps -w | grep -v grep | grep 'filebrowser -a' >/dev/null")==0
o(e)
end
function action_check()
local e=t.to_check()
o(e)
end
function action_download()
local a=nil
local i=e.formvalue("task")
if i=="extract"then
a=t.to_extract(e.formvalue("file"))
elseif i=="move"then
a=t.to_move(e.formvalue("file"))
else
a=t.to_download(e.formvalue("url"))
end
o(a)
end
function get_log()
luci.http.write(luci.sys.exec("[ -f '/var/log/filebrowser.log' ] && cat /var/log/filebrowser.log"))
end
function clear_log()luci.sys.call("echo '' > /var/log/filebrowser.log")end
