local h=require"nixio.fs"
local o=require"luci.sys"
local d=require"luci.model.uci".cursor()
local a=require"luci.util"
local i=require"luci.i18n"
module("luci.model.cbi.filebrowser.api",package.seeall)
local r="filebrowser"
local c=
"https://api.github.com/repos/filebrowser/filebrowser/releases/latest"
local u="/usr/bin/wget"
local m={
"--no-check-certificate","--quiet","--timeout=10","--tries=2"
}
local l=300
local s=nil
local n=nil
function uci_get_type(a,t,e)
value=d:get_first(r,a,t,e)or o.exec(
"echo -n `uci -q get "..r..".@"..a.."[0]."..
t.."`")
if(value==nil or value=="")and(e and e~="")then
value=e
end
return value
end
local function d(t,e)
e=e or 1
if t[e]~=nil then return t[e],d(t,e+1)end
end
local function t(h,r,i,o)
local a=require"os"
local e=require"nixio"
local s,n=e.pipe()
local t=e.fork()
if t>0 then
n:close()
if i or o then
local n=a.time()
while true do
if o and a.difftime(a.time(),n)>=o then
e.kill(t,e.const.SIGTERM)
return 1
end
if i then
local e=s:read(2048)
if e and#e>0 then
i(e)
end
end
local t,n,a=e.waitpid(t,"nohang")
if t and n=="exited"then return a end
if not i and o then e.nanosleep(1)end
end
else
local t,e,a=e.waitpid(t)
return t and e=="exited"and a
end
elseif t==0 then
e.dup(n,e.stdout)
s:close()
n:close()
e.exece(h,r,nil)
e.stdout:close()
a.exit(1)
end
end
local function f(t,e,o)
local n=table
local i=a.split(t,"[%.%-]",nil,true)
local o=a.split(o,"[%.%-]",nil,true)
local t=n.getn(i)
local a=n.getn(o)
if(t<a)then t=a end
for t=1,t,1 do
local a=i[t]or""
local t=o[t]or""
if e=="~="and(a~=t)then return true end
if(e=="<"or e=="<=")and(a<t)then return true end
if(e==">"or e==">=")and(a>t)then return true end
if(a~=t)then return false end
end
return not(e=="<"or e==">")
end
local function y()
local e=nixio.uname().machine or""
if h.access("/usr/lib/os-release")then
s=o.exec(
"echo -n `grep 'LEDE_BOARD' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}'`")
end
if h.access("/etc/openwrt_release")then
n=o.exec(
"echo -n `grep 'DISTRIB_TARGET' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}'`")
end
if e=="mips"then
if s and s~=""then
if string.match(s,"ramips")=="ramips"then
e="ramips"
else
e=o.exec("echo '"..s..
"' | grep -oE 'ramips|ar71xx'")
end
elseif n and n~=""then
if string.match(n,"ramips")=="ramips"then
e="ramips"
else
e=o.exec("echo '"..n..
"' | grep -oE 'ramips|ar71xx'")
end
end
end
return a.trim(e)
end
local function w(e)
local t=""
local a=""
if e=="x86_64"then
t="amd64"
elseif e=="aarch64"then
t="arm64"
elseif e=="ramips"then
t="mipsle"
elseif e=="ar71xx"then
t="mips"
elseif e:match("^i[%d]86$")then
t="386"
elseif e:match("^armv[5-8]")then
t="armv"
a=e:match("[5-8]")
if s and string.match(s,"bcm53xx")=="bcm53xx"then
a="5"
elseif n and string.match(n,"bcm53xx")==
"bcm53xx"then
a="5"
end
a="5"
end
return t,a
end
local function n(e)
local t=require"luci.jsonc"
local a={}
local e=luci.sys.exec(u..
" --no-check-certificate --timeout=10 -t 1 -O- "..
e)
if e==""then return{}end
return t.parse(e)or{}
end
function get_version()return uci_get_type("global","version","0")end
function to_check(e)
if not e or e==""then e=y()end
local s,h=w(e)
if s==""then
return{
code=1,
error=i.translate(
"Can't determine ARCH, or ARCH not supported.")
}
end
local e=n(c)
if e.tag_name==nil then
return{
code=1,
error=i.translate("Get remote version info failed.")
}
end
local n=e.tag_name:match("[^v]+")
local a=f(get_version(),"<",n)
local t,o
if a then
t=e.html_url
for t,e in ipairs(e.assets)do
if e.name and e.name:match("linux%-"..s..h)then
o=e.browser_download_url
break
end
end
end
if a and not o then
return{
code=1,
version=n,
html_url=t,
error=i.translate(
"New version found, but failed to get new version download url.")
}
end
return{
code=0,
update=a,
version=n,
url={html=t,download=o}
}
end
function to_download(e)
if not e or e==""then
return{code=1,error=i.translate("Download url is required.")}
end
o.call("/bin/rm -f /tmp/filebrowser_download.*")
local a=a.trim(a.exec(
"mktemp -u -t filebrowser_download.XXXXXX"))
local o=t(u,{"-O",a,e,d(m)},nil,
l)==0
if not o then
t("/bin/rm",{"-f",a})
return{
code=1,
error=i.translatef("File download failed or timed out: %s",e)
}
end
return{code=0,file=a}
end
function to_extract(e,n)
if not e or e==""or not h.access(e)then
return{code=1,error=i.translate("File path required.")}
end
o.call("/bin/rm -rf /tmp/filebrowser_extract.*")
local o=a.trim(a.exec(
"mktemp -d -t filebrowser_extract.XXXXXX"))
local n={}
t("/bin/tar",{"-C",o,"-zxvf",e},
function(e)n[#n+1]=e end)
local n=a.split(table.concat(n))
t("/bin/rm",{"-f",e})
if not new_file then
for t,e in pairs(n)do
if e:match("filebrowser")then
new_file=o.."/"..a.trim(e)
break
end
end
end
if not new_file then
t("/bin/rm",{"-rf",o})
return{
code=1,
error=i.translatef("Can't find client in file: %s",e)
}
end
return{code=0,file=new_file}
end
function to_move(n)
if not n or n==""or not h.access(n)then
o.call("/bin/rm -rf /tmp/filebrowser_extract.*")
return{code=1,error=i.translate("Client file is required.")}
end
local e=
uci_get_type("global","executable_directory","/tmp")
luci.sys.exec("mkdir -p "..e)
local e=e.."/"..r
local a
if h.access(e)then
a="/tmp/"..r..".bak"
t("/bin/mv",{"-f",e,a})
end
local n=t("/bin/mv",{"-f",n,e},nil,
l)==0
if not n or not h.access(e)then
if a then
t("/bin/mv",{"-f",a,e})
end
return{
code=1,
error=i.translatef("Can't move new file to path: %s",
e)
}
end
t("/bin/chmod",{"755",e})
if a then t("/bin/rm",{"-f",a})end
o.call("/bin/rm -rf /tmp/filebrowser_extract.*")
return{code=0}
end
